﻿using SingularSys.Jep.Standard;
using NUnit.Framework;
using SingularSys.Jep.Types;

namespace SingularSys.Jep.JepTests.Standard
{


    /// <summary>
    ///This is a test class for ComplexTest and is intended
    ///to contain all ComplexTest Unit Tests
    ///</summary>
    [TestFixture]
    public class ComplexTest
    {

        // FROM VS 2008 PROFESSIONAL --- START
        //private TestContext testContextInstance;

        ///// <summary>
        /////Gets or sets the test context which provides
        /////information about and functionality for the current test run.
        /////</summary>
        //public TestContext TestContext
        //{
        //    get
        //    {
        //        return testContextInstance;
        //    }
        //    set
        //    {
        //        testContextInstance = value;
        //    }
        //}

        //#region Additional test attributes
        //// 
        ////You can use the following additional attributes as you write your tests:
        ////
        ////Use ClassInitialize to run code before running the first test in the class
        ////[ClassInitialize()]
        ////public static void MyClassInitialize(TestContext testContext)
        ////{
        ////}
        ////
        ////Use ClassCleanup to run code after all tests in a class have run
        ////[ClassCleanup()]
        ////public static void MyClassCleanup()
        ////{
        ////}
        ////
        ////Use TestInitialize to run code before running each test
        ////[TestInitialize()]
        ////public void MyTestInitialize()
        ////{
        ////}
        ////
        ////Use TestCleanup to run code after each test has run
        ////[TestCleanup()]
        ////public void MyTestCleanup()
        ////{
        ////}
        ////
        //#endregion
        // FROM VS 2008 PROFESSIONAL --- END

        /// <summary>
        ///A test for ToString
        ///</summary>
        [Test]
        public void ToStringTest()
        {
            Complex target = new Complex(1.2, 3.4);
            string expected = "(1.2, 3.4)";
            string actual;
            actual = target.ToString();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for TanH
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void TanHTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Tanh();
            Assert.IsTrue(expected.IsEqual(actual));
        }

        /// <summary>
        ///A test for Tan
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void TanTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Tan();
            Assert.IsTrue(expected.IsEqual(actual));
            // Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for Sub
        ///</summary>
        [Test]
        public void SubTest()
        {
            Complex target = new Complex(3, 3);
            Complex b = new Complex(2, 2);
            Complex expected = new Complex(1, 1);
            Complex actual;
            actual = target.Sub(b);
            Assert.IsTrue(expected.IsEqual(actual));
        }

        /// <summary>
        ///A test for Sqrt
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void SqrtTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Sqrt();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for SinH
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void SinHTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Sinh();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for Sin
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void SinTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Sin();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for SetRe
        ///</summary>
        [Test]
        public void SetReTest()
        {
            Complex target = new Complex(1.1, 1.1);
            double re_in = 2.2;
            target.Re = re_in;
            Assert.IsTrue(target.IsEqual(new Complex(2.2, 1.1)));
        }

        /// <summary>
        ///A test for SetIm
        ///</summary>
        [Test]
        public void SetImTest()
        {
            Complex target = new Complex(1.1, 1.1);
            double im_in = 2.2;
            target.Im = im_in;
            Assert.IsTrue(target.IsEqual(new Complex(1.1, 2.2)));
        }

        /// <summary>
        ///A test for Set
        ///</summary>
        [Test]
        public void SetTest1()
        {
            Complex target = new Complex(1.1, 1.1);
            double re_in = 2.2;
            double im_in = 2.2;
            target.Set(re_in, im_in);
            Assert.IsTrue(target.IsEqual(new Complex(2.2, 2.2)));
        }

        /// <summary>
        ///A test for Set
        ///</summary>
        [Test]
        public void SetTest()
        {
            Complex target = new Complex(1.1, 1.1);
            Complex z = new Complex(2.2, 2.2);
            target.Set(z);
            Assert.IsTrue(target.IsEqual(new Complex(2.2, 2.2)));
        }

        /// <summary>
        ///A test for Power
        ///</summary>
        [Test]
        public void PowerTestDouble()
        {
            Complex one = new Complex(1, 0);
            Complex negOne = new Complex(-1, 0);
            Complex i = new Complex(0, 1);

            Assert.IsTrue((one.Pow(-1)).IsEqual(one, 0));
            Assert.IsTrue((one.Pow(1)).IsEqual(one, 0));
            Assert.IsTrue((negOne.Pow(2)).IsEqual(one, 0));
            Assert.IsTrue((i.Pow(2)).IsEqual(negOne, 0));
        }

        /// <summary>
        ///A test for Power
        ///</summary>
        [Test]
        public void PowerTestComplex()
        {
            Complex one = new Complex(1, 0);
            Complex negOne = new Complex(-1, 0);
            Complex i = new Complex(0, 1);
            Complex two = new Complex(2, 0);

            Assert.IsTrue((one.Pow(one)).IsEqual(one, 0));
            Assert.IsTrue((one.Pow(negOne)).IsEqual(one, 0));
            Assert.IsTrue((negOne.Pow(two)).IsEqual(one, 0));
            Assert.IsTrue((i.Pow(two)).IsEqual(negOne, 0));
        }

        /// <summary>
        ///A test for Neg
        ///</summary>
        [Test]
        public void NegTest()
        {
            Complex target = new Complex(1.1, 1.1);
            Complex expected = new Complex(-1.1, -1.1);
            Complex actual;
            actual = target.Neg();
            Assert.IsTrue(expected.IsEqual(actual));
        }

        /// <summary>
        ///A test for Mul
        ///</summary>
        [Test]
        public void MulTestDouble()
        {
            Complex one = new Complex(1, 0);
            Complex negOne = new Complex(-1, 0);
            Complex i = new Complex(0, 1);

            Assert.IsTrue((one.Mul(1)).IsEqual(one, 0));
            Assert.IsTrue((one.Mul(-1)).IsEqual(negOne, 0));
            Assert.IsTrue((negOne.Mul(1)).IsEqual(negOne, 0));
        }

        /// <summary>
        ///A test for Mul
        ///</summary>
        [Test]
        public void MulTestComplex()
        {
            Complex one = new Complex(1, 0);
            Complex negOne = new Complex(-1, 0);
            Complex i = new Complex(0, 1);

            Assert.IsTrue((one.Mul(one)).IsEqual(one, 0));
            Assert.IsTrue((one.Mul(negOne)).IsEqual(negOne, 0));
            Assert.IsTrue((negOne.Mul(one)).IsEqual(negOne, 0));
            Assert.IsTrue((i.Mul(i)).IsEqual(negOne, 0));
        }

        /// <summary>
        ///A test for LongValue
        ///</summary>
        [Test]
        public void LongValueTest()
        {
            Complex target = new Complex(1234567890123456, 123);
            long expected = 1234567890123456;
            long actual;
            actual = target.LongValue();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Log
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void LogTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Log();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for IsNaN
        ///</summary>
        [Test]
        public void IsNaNTest()
        {
            // Positive real component test
            Complex target = new Complex(double.NaN, 1.1);
            bool expected = true;
            bool actual;
            actual = target.IsNaN();
            Assert.AreEqual(expected, actual);

            // Positive imaginary component test
            target = new Complex(1.1, double.NaN);
            expected = true;
            actual = target.IsNaN();
            Assert.AreEqual(expected, actual);

            // Both positive  test
            target = new Complex(double.NaN, double.NaN);
            expected = true;
            actual = target.IsNaN();
            Assert.AreEqual(expected, actual);

            // Both negative test
            target = new Complex(1.1, 1.1);
            expected = false;
            actual = target.IsNaN();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for IsInfinite
        ///</summary>
        [Test]
        public void IsInfiniteTest()
        {
            // Positive infinity real component test
            Complex target = new Complex(double.PositiveInfinity, 1.1);
            bool expected = true;
            bool actual;
            actual = target.IsInfinite();
            Assert.AreEqual(expected, actual);
            // Negative infinity real component test
            target = new Complex(double.NegativeInfinity, 1.1);
            expected = true;
            actual = target.IsInfinite();
            Assert.AreEqual(expected, actual);

            // Positive infinity imaginary component test
            target = new Complex(1.1, double.PositiveInfinity);
            expected = true;
            actual = target.IsInfinite();
            Assert.AreEqual(expected, actual);
            // Negative infinity imaginary component test
            target = new Complex(1.1, double.NegativeInfinity);
            expected = true;
            actual = target.IsInfinite();
            Assert.AreEqual(expected, actual);

            // Both positive infinity test
            target = new Complex(double.PositiveInfinity, double.PositiveInfinity);
            expected = true;
            actual = target.IsInfinite();
            Assert.AreEqual(expected, actual);
            // Both negative infinity test
            target = new Complex(double.NegativeInfinity, double.NegativeInfinity);
            expected = true;
            actual = target.IsInfinite();
            Assert.AreEqual(expected, actual);

            // Both not infinite test
            target = new Complex(1.1, 1.1);
            expected = false;
            actual = target.IsInfinite();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for IsEqual
        ///</summary>
        [Test]
        public void IsEqualTestTolerance()
        {
            Complex target = new Complex(1.1, 1.1);
            Complex b = new Complex(1.1, 1.1);
            double tolerance = 0.0;
            bool expected = true;
            bool actual;
            actual = target.IsEqual(b, tolerance);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for IsEqual
        ///</summary>
        [Test]
        public void IsEqualTestObject()
        {
            Complex target = new Complex(1.1, 1.1);
            object o = new Complex(1.1, 1.1);
            bool expected = true;
            bool actual;
            actual = target.IsEqual(o);
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for IntValue
        ///</summary>
        [Test]
        public void IntValueTest()
        {
            Complex target = new Complex(123, 1.1);
            int expected = 123;
            int actual;
            actual = target.IntValue();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for HashCode
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void HashCodeTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            int expected = 0; // TODO: Initialize to an appropriate value
            int actual;
            actual = target.HashCode();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for GetRe
        ///</summary>
        [Test]
        public void GetReTest()
        {
            Complex target = new Complex(1.1, 2.2);
            double expected = 1.1;
            double actual;
            actual = target.Re;
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for GetIm
        ///</summary>
        [Test]
        public void GetImTest()
        {
            Complex target = new Complex(1.1, 2.2);
            double expected = 2.2;
            double actual;
            actual = target.Im;
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for FloatValue
        ///</summary>
        [Test]
        public void FloatValueTest()
        {
            Complex target = new Complex(1.1, 2.2);
            float expected = 1.1F;
            float actual;
            actual = target.FloatValue();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for DoubleValue
        ///</summary>
        [Test]
        public void DoubleValueTest()
        {
            Complex target = new Complex(1.1, 2.2);
            double expected = 1.1;
            double actual;
            actual = target.DoubleValue();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Div
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void DivTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex b = null; // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Div(b);
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for CosH
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void CosHTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Cosh();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for Cos
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void CosTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Cos();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for Conj
        ///</summary>
        [Test]
        public void ConjTest()
        {
            Complex target = new Complex(1.1, 2.2);
            Complex expected = new Complex(1.1, -2.2);
            Complex actual;
            actual = target.Conj();
            Assert.IsTrue(expected.IsEqual(actual));
        }

        /// <summary>
        ///A test for ATanH
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void ATanHTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Atanh();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for ATan
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void ATanTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Atan();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for ASinH
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void ASinHTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Asinh();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for ASin
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void ASinTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Asin();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for Arg
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void ArgTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            double expected = 0F; // TODO: Initialize to an appropriate value
            double actual;
            actual = target.Arg();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for Add
        ///</summary>
        [Test]
        public void AddTest()
        {
            Complex target = new Complex(1.1, 2.2);
            Complex b = new Complex(3.3, 5.5);
            Complex expected = new Complex(4.4, 7.7);
            Complex actual;
            actual = target.Add(b);
            Assert.IsTrue(expected.IsEqual(actual));
        }

        /// <summary>
        ///A test for ACosH
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void ACosHTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Acosh();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for ACos
        ///</summary>
        [Test]
        [Ignore("TODO - Complete Test")]
        public void ACosTest()
        {
            Complex target = new Complex(); // TODO: Initialize to an appropriate value
            Complex expected = null; // TODO: Initialize to an appropriate value
            Complex actual;
            actual = target.Acos();
            Assert.AreEqual(expected, actual);
            //Assert.Inconclusive("Verify the correctness of this test method.");
        }

        /// <summary>
        ///A test for Abs2
        ///</summary>
        [Test]
        public void Abs2Test()
        {
            Complex target = new Complex(2.0, 3.0);
            double expected = 13;
            double actual;
            actual = target.Abs2();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Abs
        ///</summary>
        [Test]
        public void AbsTest()
        {
            Complex target = new Complex(3.0, 4.0);
            double expected = 5;
            double actual;
            actual = target.Abs();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Complex Constructor
        ///</summary>
        [Test]
        public void ComplexConstructorTestDoubleReal()
        {
            double re_in = 1.1; // TODO: Initialize to an appropriate value
            Complex target = new Complex(re_in);
            double actual = target.Re;
            double expected = 1.1;
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for Complex Constructor
        ///</summary>
        [Test]
        public void ComplexConstructorTestNull()
        {
            Complex target = new Complex();
            Complex actual = new Complex(0, 0);
            Assert.IsTrue(target.IsEqual(actual));
        }

        /// <summary>
        ///A test for Complex Constructor
        ///</summary>
        [Test]
        public void ComplexConstructorTestDoubleBoth()
        {
            double re_in = 1.1;
            double im_in = 2.2;
            Complex target = new Complex(re_in, im_in);
            double expectedre = 1.1;
            double actualre = target.Re;
            double expectedim = 2.2;
            double actualim = target.Im;
            Assert.AreEqual(expectedim, actualim);
            Assert.AreEqual(expectedre, actualre);
        }

        /// <summary>
        ///A test for Complex Constructor
        ///</summary>
        [Test]
        public void ComplexConstructorTestComplex()
        {
            Complex z = new Complex(1.1, 2.2);
            Complex target = new Complex(z);
            Assert.IsTrue(target.IsEqual(z));
        }
    }
}
